
datablock AudioProfile(M40A3FireSound)
{
   filename    = "./M40A3fire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(M40A3boltSound)
{
   filename    = "./M40A3bolt.wav";
   description = AudioClose3d;
   preload = true;
};
datablock ParticleData(M40A3SmokeParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -0.5;
        inheritedVelFactor   = 0.2;
        constantAcceleration = 0.0;
        lifetimeMS           = 525;
        lifetimeVarianceMS   = 55;
        textureName          = "base/data/particles/star1"; //this was a fail but ended up being a cool spark effect
        spinSpeed                = 10.0;
        spinRandomMin                = -500.0;
        spinRandomMax                = 500.0;
        colors[0]     = "1 1 0.0 0.9";
        colors[1]     = "0.9 0.0 0.0 0.0";
        sizes[0]      = 0.15;
        sizes[1]      = 0.15;
        useInvAlpha = false;
};
datablock ParticleEmitterData(M40A3SmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M40A3SmokeParticle";
   uiName = "M40A3 Explosion";
};
datablock ExplosionData(M40A3Explosion)
{
soundProfile = bulletHitSound;
  lifeTimeMS = 50;
  emitter[0] = M40A3SmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
};
datablock ParticleData(M40A3TrailParticle)
{
        dragCoefficient      = 3;
        gravityCoefficient   = -0.0;
        inheritedVelFactor   = 0.0;
        constantAcceleration = 0.0;
        lifetimeMS           = 625;
        lifetimeVarianceMS   = 55;
        textureName          = "base/data/particles/thinRing";
        spinSpeed                = 10.0;
        spinRandomMin                = -500.0;
        spinRandomMax                = 500.0;
        colors[0]     = "0.3 0.3 0.9 0.4";
        colors[1]     = "0.5 0.5 0.5 0.0";
        sizes[0]      = 0.15;
        sizes[1]      = 0.25;

        useInvAlpha = false;
};
datablock ParticleEmitterData(M40A3TrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "M40A3TrailParticle";
};

AddDamageType("M40A3Headshot",   '<bitmap:add-ons/Weapon_M40A3/CI_M40A3headshot> %1',    '%2 <bitmap:add-ons/Weapon_M40A3/CI_M40A3headshot> %1',0.5,1);
datablock ProjectileData(M40A3Projectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 100;
   directDamageType    = $DamageType::M40A3Headshot;
   //radiusDamageType    = $DamageType::M40A3;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = M40A3Explosion;
 particleEmitter     = M40A3TrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};
AddDamageType("M40A3",   '<bitmap:Add-ons/Weapon_M40a3/CI_M40A3> %1',    '%2 <bitmap:Add-ons/Weapon_M40A3/CI_M40A3> %1',0.5,1);
datablock ProjectileData(M40A3Projectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 50;
   directDamageType    = $DamageType::M40A3;


   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 1;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse             = 0;
   verticalImpulse          = 0;
   explosion           = M40A3Explosion;


   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   

};


//////////
// item //
//////////
datablock ItemData(M40A3Item) //ghille you idot
{
        category = "Weapon";  // Mission editor category
        className = "Weapon"; // For inventory system

         // Basic Item Properties
        shapeFile = "./M40A3.dts";
        rotate = false;
        mass = 1;
        density = 0.2;
        elasticity = 0.2;
        friction = 0.6;
        emap = true;

        //gui stuff
        uiName = "M40A3";
        iconName = "./UI_M40A3";
        doColorShift = false;
        colorShiftColor = "1 1 1 1.000";

         // Dynamic properties defined by the scripts
        image = M40A3Image;
        canDrop = true;
                   maxAmmo = 5; 
   canReload = 1;
};




datablock ShapeBaseImageData(M40A3Image)
{
   // Basic Item properties
   shapeFile = "./M40A3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = M40A3Item;
   ammo = " ";
   projectile = M40A3Projectile;
   projectileType = Projectile;

        casing = GunShellDebris;
        shellExitDir        = "1.0 -1.3 1.0";
        shellExitOffset     = "0 0 0";
        shellExitVariance   = 15.0;        
        shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
// Initial start up state
              stateName[0]                            = "Activate";
        stateTimeoutValue[0]                    = 0.67;
//        stateSequence[0]                         = "Use";
        stateTransitionOnTimeout[0]             = "LoadCheckA";
        stateSound[0]                                  = weaponSwitchSound;

        stateName[1]                            = "Ready";
       stateTransitionOnTriggerDown[1]         = "Fire";
        stateTransitionOnNoAmmo[1]                = "ReloadCheckA";
        stateAllowImageChange[1]                = true;

        stateName[2]                            = "Fire";
        stateTransitionOnTimeout[2]             = "Smoke";
        stateTimeoutValue[2]                    = 0.1;
        stateFire[2]                            = true;
        stateAllowImageChange[2]                = false;
//        stateSequence[2]                        = "Fire";
        stateScript[2]                          = "onFire";
        stateWaitForTimeout[2]                          = true;
        stateEmitter[2]                                  = gunFlashEmitter;
        stateEmitterTime[2]                          = 0.05;
        stateEmitterNode[2]                          = "muzzleNode";
        stateSound[2]                                  = M40A3fireSound;

        stateName[3]                                   = "Smoke";
        stateEmitter[3]                                  = gunSmokeEmitter;
        stateEmitterTime[3]                          = 0.1;
        stateEmitterNode[3]                          = "muzzleNode";
        stateTimeoutValue[3]                    = 0.2;
        stateTransitionOnTimeout[3]             = "Eject";

        stateName[4]                                  = "Eject";
        stateTimeoutValue[4]                          = 0.7;
        stateTransitionOnTimeout[4]                  = "LoadCheckA";
        stateWaitForTimeout[4]                          = true;
        stateEjectShell[4]                         = true;
        stateSequence[4]                        = "Fire";
        stateSound[4]                                  = M40A3BoltSound;
        stateScript[4]                          = "onEject";
        
        stateName[5]                                = "LoadCheckA";
        stateScript[5]                                = "onLoadCheck";
        stateTimeoutValue[5]                        = 0.01;
        stateTransitionOnTimeout[5]                = "LoadCheckB";
                                                
        stateName[6]                                = "LoadCheckB";
        stateTransitionOnAmmo[6]                = "Ready";
        stateTransitionOnNoAmmo[6]                = "ForceReload";
        
        stateName[7]                                = "ReloadCheckA";
        stateScript[7]                                = "onReloadCheck";
        stateTimeoutValue[7]                        = 0.01;
        stateTransitionOnTimeout[7]                = "ReloadCheckB";
                                                
        stateName[8]                                = "ReloadCheckB";
        stateTransitionOnAmmo[8]                = "CompleteReload";
        stateTransitionOnNoAmmo[8]                = "Reload";
                                                
        stateName[9]                                = "ForceReload";
        stateTransitionOnTimeout[9]             = "ForceReloaded";
        stateTimeoutValue[9]                        = 0.3;
//        stateSequence[9]                        = "Reload";
        stateSound[9]                                = Block_MoveBrick_Sound;
        stateScript[9]                                = "onReloadStart";
        
        stateName[10]                                = "ForceReloaded";
        stateTransitionOnTimeout[10]             = "ReloadCheckA";
        stateTimeoutValue[10]                        = 0.2;
        stateScript[10]                                = "onReloaded";
        
        stateName[11]                                = "Reload";
        stateTransitionOnTimeout[11]             = "Reloaded";
        stateTransitionOnTriggerDown[11]        = "Fire";
        stateWaitForTimeout[11]                        = false;
        stateTimeoutValue[11]                        = 0.53;
//        stateSequence[11]                        = "Fire";
        stateSound[11]                                = Block_MoveBrick_Sound;
        stateScript[11]                                = "onReloadStart";
        
        stateName[12]                                = "Reloaded";
        stateTransitionOnTimeout[12]             = "ReloadCheckA";
        stateTransitionOnTriggerDown[12]        = "Fire";
        stateWaitForTimeout[12]                        = false;
        stateTimeoutValue[12]                        = 0.0;
        stateScript[12]                                = "onReloaded";

        stateName[13]                                  = "CompleteReload";
        stateTimeoutValue[13]                          = 0.5;
        stateTransitionOnTriggerUp[13]                  = "Ready";
        stateWaitForTimeout[13]                          = true;
        stateSequence[13]                        = "Fire";
        stateSound[13]                                  = M40A3boltSound;
        stateScript[13]                          = "onEject";
};

function M40A3Image::onReloadCheck(%this,%obj,%slot)
{
 if(%obj.toolAmmo[%obj.currTool] < %this.item.maxAmmo && %this.item.maxAmmo > 0 && %obj.getState() !$= "Dead")
  %obj.setImageAmmo(%slot,0);
 else
  %obj.setImageAmmo(%slot,1);
}
function M40A3Image::onReloaded(%this,%obj,%slot)
{
 %obj.toolAmmo[%obj.currTool]++;
        %obj.setImageAmmo(%slot,1);
 commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "5 " @ "", 4, 2, 3, 4);
}
function M40A3Image::onReloadStart(%this,%obj,%slot)
{
        %obj.playThread(2, shiftLeft);
}

function M40A3Image::onUnMount(%this,%obj,%slot)
{
        %obj.playThread(2, root);
}

function M40A3Image::onFire(%this,%obj,%slot)
{ 
        %obj.toolAmmo[%obj.currTool]--;
        commandToClient(%obj.client,'bottomPrint',"<color:0aa000><just:right><font:impact:38>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ "5 " @ "", 4, 2, 3, 4); 

        if(%obj.getDamagePercent() < 1.0)
                %obj.playThread(2, plant);
                
%projectile = %this.projectile;
  %spread = 0.000;
  %shellcount = 1;
  for(%shell=0;%shell<%shellcount;%shell++)
  {
    %vector = %obj.getMuzzleVector(%slot);
    %objectVelocity = %obj.getVelocity();
    %vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
    %vector2 = VectorScale(%objectVelocity,%projectile.velInheritFactor);
    %velocity = VectorAdd(%vector1,%vector2);
    %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
    %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
    %velocity = MatrixMulVector(%mat,%velocity);
    %p = new (%this.projectileType)()
    {
      dataBlock = %projectile;
      initialVelocity = %velocity;
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject = %obj;
      sourceSlot = %slot;
      client = %obj.client;
    };
   MissionCleanup.add(%p);
  return %p;
  }
}

function M40A3Projectile::Damage(%this,%obj,%col,%fade,%pos,%normal)
{
  if(%col.getClassName() $="Player" || %col.getClassName() $= "AIPlayer")
  {
    if(%col.getClassName() $= "AIPlayer")
    {
      %oldClient = %col.client;
      %col.client = BotConnection;
      %hitBoxList = getHitbox(%obj,%col,%pos);
      %col.client = %oldClient;
    }
    else
    {
      %hitBoxList = getHitbox(%obj,%col,%pos);
    }
    if(strReplace(%hitBoxList,"headskin","BAM") $= %hitBoxList)
    {
      parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
    }
    else
    {
      %col.damage(%obj,%pos,120 / %obj.getScale(),$DamageType::M40A3Headshot);
    }
  }
  else
  {
    parent::Damage(%this,%obj,%col,%fade,%pos,%normal);
  }
}

datablock ShapeBaseImageData(M40A3RunningImage)
{
   shapeFile = "./M40A3Run.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.8 -0.5 -0.1";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleM40A3 = true;

   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = M40A3Item.colorShiftColor;//"0.400 0.196 0 1.000";

   casing = " ";

        stateName[0]                     = "Activate";
        stateTimeoutValue[0]             = 0.15;
        stateSound[0]                                        = weaponSwitchSound;
};


package M40A3Switch
{
          function Armor::onTrigger(%this, %player, %slot, %val)

        {

                if(isObject(%player.getMountedImage(0)))

                {

                        if((%player.getMountedImage(0).getName() $= "M40A3Image" || %player.getMountedImage(0).getName() $= "M40A3RunningImage") && %slot $= 4 && %val)

                        {

                                switch$(%player.getMountedImage(0).getName())

                                {

        

                                        case "M40A3Image":

                                                %player.mountImage(M40A3RunningImage,0);

                                        case "M40A3RunningImage":

                                                %player.mountImage(M40A3Image,0);

                                }

                         

                        }

                        else

                        {

                                Parent::onTrigger(%this, %player, %slot, %val);

                        }

                }

                else

                {

                        Parent::onTrigger(%this, %player, %slot, %val);

                }

        }
};
ActivatePackage(M40A3Switch);

function M40A3RunningImage::onMount(%this,%obj,%slot)
{
        %obj.client.player.m40a3_lastDatablock = %obj.client.player.getDatablock();

        %obj.client.player.setDataBlock("GunSprintArmor");
        
        %obj.hidenode("RHand");
        %obj.hidenode("LHand");
}

function M40A3RunningImage::onUnMount(%this,%obj,%slot)
{        
        %obj.unhidenode("RHand");
        %obj.unhidenode("LHand");
        
        %client = %obj.client;
                if(isObject(%client.player.m40a3_lastDatablock))
                {
                        %client.player.setDataBlock(%client.player.M40A3_lastDatablock);
                }else{
                       %client.player.setDataBlock("PlayerStandardArmor");
                }
}
